		.686
		.MODEL flat
		.MMX
		.XMM

		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		; MMX code for Meia2 by fccHandler
		; VirtualDub-MPEG2 1.6.19
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	; Beware, none of these end with "emms"

;                Number of
; Operation   Functional Units   Latency   Throughput   Execution Pipes
; ---------   ----------------   -------   ----------   ---------------
; ALU                      2        1          1        U and V
; Multiplexer              1        3          1        U or V
; Shift/pack/unpack        1        1          1        U or V
; Memory access            1        1          1        U only
; Integer register access  1        1          1        U only

; * The Arithmetic Logic Unit (ALU) executes arithmetic and logic operations
;   (that is, add, subtract, xor, and).
;
; * The Multiplier unit performs all multiplication operations. Multiplication
;   requires three cycles but can be pipelined, resulting in one multiplication
;   operation every clock cycle. The processor has only one multiplier unit which
;   means that multiplication instructions cannot pair with other multiplication
;   instructions. However, the multiplication instructions can pair with other
;   types of instructions. They can execute in either the U- or V-pipes.
;
; * The Shift unit performs all shift, pack and unpack operations. Only one shifter
;   is available so shift, pack and unpack instructions cannot pair with other shift
;   unit instructions. However, the shift unit instructions can pair with other types
;   of instructions. They can execute in either the U- or V-pipes.
;
; * MMX Technology Instructions that access memory or integer registers can only
;   execute in the U-pipe and cannot be paired with any instructions that are not
;   MMX Technology instructions.
;
; * After updating an MMX Technology register, two clock cycles must pass before that
;   MMX Technology register can be moved to either memory or to an integer register.

		.DATA

	SHIFT_INV_ROW   = 11
	SHIFT_INV_COL   = 6

	ALIGN 16

	tg_1_16		WORD  13036,  13036,  13036,  13036
	tg_2_16		WORD  27146,  27146,  27146,  27146
	tg_3_16		WORD -21746, -21746, -21746, -21746
	cos_4_16	WORD  23170,  23170,  23170,  23170

	rounder_0	DWORD 65536, 65536
	rounder_4	DWORD 0, 0
	rounder_1	DWORD 3597, 3597
	rounder_7	DWORD 512, 512
	rounder_2	DWORD 2260, 2260
	rounder_6	DWORD 512, 512
	rounder_3	DWORD 1203, 1203
	rounder_5	DWORD 120, 120

; Tables for MMX IDCT

	tab_i_04	WORD  16384,  16384,  16384, -16384
				WORD  21407,   8867,   8867, -21407
				WORD  16384, -16384,  16384,  16384
				WORD  -8867,  21407, -21407,  -8867
				WORD  22725,  12873,  19266, -22725
				WORD  19266,   4520,  -4520, -12873
				WORD  12873,   4520,   4520,  19266
				WORD -22725,  19266, -12873, -22725

	tab_i_17	WORD  22725,  22725,  22725, -22725
				WORD  29692,  12299,  12299, -29692
				WORD  22725, -22725,  22725,  22725
				WORD -12299,  29692, -29692, -12299
				WORD  31521,  17855,  26722, -31521
				WORD  26722,   6270,  -6270, -17855
				WORD  17855,   6270,   6270,  26722
				WORD -31521,  26722, -17855, -31521

	tab_i_26	WORD  21407,  21407,  21407, -21407
				WORD  27969,  11585,  11585, -27969
				WORD  21407, -21407,  21407,  21407
				WORD -11585,  27969, -27969, -11585
				WORD  29692,  16819,  25172, -29692
				WORD  25172,   5906,  -5906, -16819
				WORD  16819,   5906,   5906,  25172
				WORD -29692,  25172, -16819, -29692

	tab_i_35	WORD  19266,  19266,  19266, -19266
				WORD  25172,  10426,  10426, -25172
				WORD  19266, -19266,  19266,  19266
				WORD -10426,  25172, -25172, -10426
				WORD  26722,  15137,  22654, -26722
				WORD  22654,   5315,  -5315, -15137
				WORD  15137,   5315,   5315,  22654
				WORD -26722,  22654, -15137, -26722

; Tables for ISSE IDCT

	tab_i_04_sse	WORD  16384,  21407,  16384,   8867
					WORD  16384,   8867, -16384, -21407
					WORD  16384,  -8867,  16384, -21407
					WORD -16384,  21407,  16384,  -8867
					WORD  22725,  19266,  19266,  -4520
					WORD  12873,   4520, -22725, -12873
					WORD  12873, -22725,   4520, -12873
					WORD   4520,  19266,  19266, -22725

	tab_i_17_sse	WORD  22725,  29692,  22725,  12299
					WORD  22725,  12299, -22725, -29692
					WORD  22725, -12299,  22725, -29692
					WORD -22725,  29692,  22725, -12299
					WORD  31521,  26722,  26722,  -6270
					WORD  17855,   6270, -31521, -17855
					WORD  17855, -31521,   6270, -17855
					WORD   6270,  26722,  26722, -31521

	tab_i_26_sse	WORD  21407,  27969,  21407,  11585
					WORD  21407,  11585, -21407, -27969
					WORD  21407, -11585,  21407, -27969
					WORD -21407,  27969,  21407, -11585
					WORD  29692,  25172,  25172,  -5906
					WORD  16819,   5906, -29692, -16819
					WORD  16819, -29692,   5906, -16819
					WORD   5906,  25172,  25172, -29692

	tab_i_35_sse	WORD  19266,  25172,  19266,  10426
					WORD  19266,  10426, -19266, -25172
					WORD  19266, -10426,  19266, -25172
					WORD -19266,  25172,  19266, -10426
					WORD  26722,  22654,  22654,  -5315
					WORD  15137,   5315, -26722, -15137
					WORD  15137, -26722,   5315, -15137
					WORD   5315,  22654,  22654, -26722

; Some prediction constants

	mmx_7F7F7F7F7F7F7F7F	LABEL QWORD
					DWORD	7F7F7F7Fh, 7F7F7F7Fh

	mmx_0101010101010101	LABEL QWORD
					DWORD	01010101h, 01010101h

	mmx_0002000200020002	LABEL QWORD
					DWORD	00020002h, 00020002h

	mmx_0006000600060006	LABEL QWORD
					DWORD	00060006h, 00060006h

	ISSE_allowed	DWORD	0


		.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MMX and ISSE IDCTs, adapted from XviD source code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DCT_8_INV_ROW_1		MACRO	src, dst, tab, rounder

	movq		mm0, QWORD PTR [src+0]

	movq		mm1, QWORD PTR [src+8]
	movq		mm2, mm0

	movq		mm3, QWORD PTR [tab+0]
	punpcklwd	mm0, mm1

	movq		mm5, mm0
	punpckldq	mm0, mm0

	movq		mm4, QWORD PTR [tab+8]
	punpckhwd	mm2, mm1

	pmaddwd		mm3, mm0
	movq		mm6, mm2

	movq		mm1, QWORD PTR [tab+32]
	punpckldq	mm2, mm2

	pmaddwd		mm4, mm2
	punpckhdq	mm5, mm5

	pmaddwd		mm0, QWORD PTR [tab+16]
	punpckhdq	mm6, mm6

	movq		mm7, QWORD PTR [tab+40]
	pmaddwd		mm1, mm5

	paddd		mm3, QWORD PTR [rounder]
	pmaddwd		mm7, mm6

	pmaddwd		mm2, QWORD PTR [tab+24]
	paddd		mm3, mm4

	pmaddwd		mm5, QWORD PTR [tab+48]
	movq		mm4, mm3

	pmaddwd		mm6, QWORD PTR [tab+56]
	paddd		mm1, mm7

	paddd		mm0, QWORD PTR [rounder]
	psubd		mm3, mm1

	paddd		mm1, mm4
	psrad		mm3, SHIFT_INV_ROW

	paddd		mm0, mm2
	psrad		mm1, SHIFT_INV_ROW

	paddd		mm5, mm6
	movq		mm4, mm0

	paddd		mm0, mm5
	psubd		mm4, mm5

	psrad		mm0, SHIFT_INV_ROW
	psrad		mm4, SHIFT_INV_ROW

	packssdw	mm1, mm0
	packssdw	mm4, mm3

	movq		mm7, mm4
	psrld		mm4, 16

	pslld		mm7, 16
	movq		QWORD PTR [dst], mm1
                        
	por			mm7, mm4
	movq		QWORD PTR [dst+8], mm7

ENDM

DCT_8_INV_ROW_1_sse		MACRO	src, dst, tab, rounder

	movq		mm0, QWORD PTR [src+0]

	movq		mm1, QWORD PTR [src+8]
	movq		mm2, mm0

	movq		mm3, QWORD PTR [tab+0]
	pshufw		mm0, mm0, 10001000b

	movq		mm4, QWORD PTR [tab+8]
	movq		mm5, mm1

	pshufw		mm1, mm1, 10001000b
	pmaddwd		mm3, mm0

	movq		mm6, QWORD PTR [tab+32]
	pmaddwd		mm4, mm1

	movq		mm7, QWORD PTR [tab+40]
	pshufw		mm2, mm2, 11011101b

	pmaddwd		mm6, mm2
	pshufw		mm5, mm5, 11011101b

	pmaddwd		mm7, mm5
	paddd		mm3, QWORD PTR [rounder]

	pmaddwd		mm0, QWORD PTR [tab+16]
	paddd		mm3, mm4

	pmaddwd		mm1, QWORD PTR [tab+24]
	movq		mm4, mm3

	pmaddwd		mm2, QWORD PTR [tab+48]
	paddd		mm6, mm7

	pmaddwd		mm5, QWORD PTR [tab+56]
	paddd		mm3, mm6

	paddd		mm0, QWORD PTR [rounder]
	psrad		mm3, SHIFT_INV_ROW

	paddd		mm0, mm1
	psubd		mm4, mm6

	movq		mm7, mm0
	paddd		mm2, mm5

	paddd		mm0, mm2
	psrad		mm4, SHIFT_INV_ROW

	psubd		mm7, mm2
	psrad		mm0, SHIFT_INV_ROW

	psrad		mm7, SHIFT_INV_ROW

	packssdw	mm3, mm0

	packssdw	mm7, mm4

	movq		QWORD PTR [dst+0], mm3
	pshufw		mm7, mm7, 10110001b

	movq		QWORD PTR [dst+8], mm7

ENDM

DCT_8_INV_COL_4		MACRO	src, dst

	movq		mm0, QWORD PTR [tg_3_16]

	movq		mm3, QWORD PTR [src+16*3]
	movq		mm1, mm0

	movq		mm5, QWORD PTR [src+16*5]
	pmulhw		mm0, mm3

	movq		mm4, QWORD PTR [tg_1_16]
	pmulhw		mm1, mm5

	movq		mm7, QWORD PTR [src+16*7]
	movq		mm2, mm4

	movq		mm6, QWORD PTR [src+16*1]
	pmulhw		mm4, mm7

	paddsw		mm0, mm3
	pmulhw		mm2, mm6

	paddsw		mm1, mm3
	psubsw		mm0, mm5

	movq		mm3, QWORD PTR [cos_4_16]
	paddsw		mm1, mm5

	paddsw		mm4, mm6
	psubsw		mm2, mm7

	movq		mm5, mm4
	movq		mm6, mm2

	paddsw		mm5, mm1
	psubsw		mm6, mm0

	psubsw		mm4, mm1
	paddsw		mm2, mm0

	movq		mm7, QWORD PTR [tg_2_16]
	movq		mm1, mm4

	movq		QWORD PTR [dst+3*16], mm5
	paddsw		mm1, mm2

	movq		QWORD PTR [dst+5*16], mm6
	psubsw		mm4, mm2

	movq		mm5, QWORD PTR [src+2*16]
	movq		mm0, mm7

	movq		mm6, QWORD PTR [src+6*16]
	pmulhw		mm0, mm5

	movq		mm2, QWORD PTR [src+0*16]
	pmulhw		mm7, mm6

	psubsw		mm0, mm6
	pmulhw		mm1, mm3

	movq		mm6, QWORD PTR [src+4*16]
	pmulhw		mm4, mm3

	movq		mm3, mm2
	paddsw		mm7, mm5

	paddsw		mm2, mm6
	psubsw		mm3, mm6

	movq		mm5, mm2
	movq		mm6, mm3

	psubsw		mm2, mm7
	paddsw		mm3, mm0

	paddsw		mm1, mm1
	paddsw		mm4, mm4

	paddsw		mm5, mm7
	psubsw		mm6, mm0

	movq		mm7, mm3
	movq		mm0, mm6

	paddsw		mm3, mm1
	paddsw		mm6, mm4

	psraw		mm3, SHIFT_INV_COL
	psubsw		mm7, mm1

	psraw		mm6, SHIFT_INV_COL
	psubsw		mm0, mm4

	movq		mm1, QWORD PTR [dst+3*16]
	psraw		mm7, SHIFT_INV_COL

	movq		mm4, mm5
	psraw		mm0, SHIFT_INV_COL

	movq		QWORD PTR [dst+1*16], mm3
	paddsw		mm5, mm1

	movq		QWORD PTR [dst+2*16], mm6
	psubsw		mm4, mm1

	movq		mm3, QWORD PTR [dst+5*16]
	psraw		mm5, SHIFT_INV_COL

	movq		mm6, mm2
	psraw		mm4, SHIFT_INV_COL

	movq		QWORD PTR [dst+5*16], mm0
	paddsw		mm2, mm3

	movq		QWORD PTR [dst+6*16], mm7
	psubsw		mm6, mm3

	movq		QWORD PTR [dst+0*16], mm5
	psraw		mm2, SHIFT_INV_COL

	movq		QWORD PTR [dst+7*16], mm4
	psraw		mm6, SHIFT_INV_COL

	movq		QWORD PTR [dst+3*16], mm2

	movq		QWORD PTR [dst+4*16], mm6
ENDM

mmx_IDCT	PROC C PUBLIC

	mov		eax, [esp+4]

	DCT_8_INV_ROW_1	eax+0, eax+0, tab_i_04, rounder_0
	DCT_8_INV_ROW_1	eax+16, eax+16, tab_i_17, rounder_1
	DCT_8_INV_ROW_1	eax+32, eax+32, tab_i_26, rounder_2
	DCT_8_INV_ROW_1	eax+48, eax+48, tab_i_35, rounder_3
	DCT_8_INV_ROW_1	eax+64, eax+64, tab_i_04, rounder_4
	DCT_8_INV_ROW_1	eax+80, eax+80, tab_i_35, rounder_5
	DCT_8_INV_ROW_1	eax+96, eax+96, tab_i_26, rounder_6
	DCT_8_INV_ROW_1	eax+112, eax+112, tab_i_17, rounder_7

	DCT_8_INV_COL_4	eax+0,eax+0
	DCT_8_INV_COL_4	eax+8,eax+8

	ret    

mmx_IDCT	ENDP

sse_IDCT	PROC C PUBLIC

	mov		eax, [esp+4]

	DCT_8_INV_ROW_1_sse	eax+0, eax+0, tab_i_04_sse, rounder_0
	DCT_8_INV_ROW_1_sse	eax+16, eax+16, tab_i_17_sse, rounder_1
	DCT_8_INV_ROW_1_sse	eax+32, eax+32, tab_i_26_sse, rounder_2
	DCT_8_INV_ROW_1_sse	eax+48, eax+48, tab_i_35_sse, rounder_3
	DCT_8_INV_ROW_1_sse	eax+64, eax+64, tab_i_04_sse, rounder_4
	DCT_8_INV_ROW_1_sse	eax+80, eax+80, tab_i_35_sse, rounder_5
	DCT_8_INV_ROW_1_sse	eax+96, eax+96, tab_i_26_sse, rounder_6
	DCT_8_INV_ROW_1_sse	eax+112, eax+112, tab_i_17_sse, rounder_7

	DCT_8_INV_COL_4	eax+0, eax+0
	DCT_8_INV_COL_4	eax+8, eax+8

	ret

sse_IDCT	ENDP

    ; mmx_Add_Block(
    ;   [esp+ 4]    void *blk,
    ;   [esp+ 8]    void *dst,
    ;   [esp+12]    int  pitch,
	;	[esp+16]	int addflag
	; );

mmx_Add_Block	PROC C PUBLIC

	push	esi
	push	edi

	mov		esi, [esp+ 4+ 8]	; blk
	mov		edi, [esp+ 8+ 8]	; dst
	mov		edx, [esp+12+ 8]	; pitch

; "blk" is a solid block of 64 WORD values
; "edi" is a sequence of 8 lines of 8 bytes each
; The lines of "edi" are separated by "pitch"

	cmp		dword ptr [esp+16+ 8], 0
	je		noadd

; Finally unrolled this!

	movq		mm1, [edi]
	pxor		mm7, mm7

	movq		mm3, [edi+edx]
	movq		mm0, mm1

	mov			ecx, edi
	lea			edi, [edi+edx*2]

	movq		mm2, mm3
	punpcklbw	mm0, mm7		; [edi] low

	paddw		mm0, [esi]
	punpckhbw	mm1, mm7		; [edi] high

	paddw		mm1, [esi+8]
	punpcklbw	mm2, mm7		; [edi+8] low

	paddw		mm2, [esi+16]
	punpckhbw	mm3, mm7		; [edi+8] high

	paddw		mm3, [esi+24]
	packuswb	mm0, mm1

	movq		mm1, [edi]
	packuswb	mm2, mm3

	movq		[ecx], mm0
	movq		mm0, mm1

	movq		[ecx+edx], mm2
	punpcklbw	mm0, mm7		; [edi] low

	movq		mm2, [edi+edx]
	punpckhbw	mm1, mm7		; [edi] high

	mov			ecx, edi
	lea			edi, [edi+edx*2]

	paddw		mm0, [esi+32]
	movq		mm3, mm2

	paddw		mm1, [esi+40]
	punpcklbw	mm2, mm7		; [edi+8] low

	paddw		mm2, [esi+48]
	punpckhbw	mm3, mm7		; [edi+8] high

	paddw		mm3, [esi+56]
	packuswb	mm0, mm1

	movq		mm1, [edi]
	packuswb	mm2, mm3

	movq		[ecx], mm0
	movq		mm0, mm1

	movq		[ecx+edx], mm2
	punpcklbw	mm0, mm7		; [edi+16] low

	movq		mm2, [edi+edx]
	punpckhbw	mm1, mm7		; [edi+16] high

	mov			ecx, edi
	lea			edi, [edi+edx*2]

	paddw		mm0, [esi+64]
	movq		mm3, mm2

	paddw		mm1, [esi+72]
	punpcklbw	mm2, mm7		; [edi+24] low

	paddw		mm2, [esi+80]
	punpckhbw	mm3, mm7		; [edi+24] high

	paddw		mm3, [esi+88]
	packuswb	mm0, mm1

	movq		mm1, [edi]
	packuswb	mm2, mm3

	movq		[ecx], mm0
	movq		mm0, mm1

	movq		[ecx+edx], mm2
	punpcklbw	mm0, mm7		; [edi+16] low

	movq		mm2, [edi+edx]
	punpckhbw	mm1, mm7		; [edi+16] high

	paddw		mm0, [esi+96]
	movq		mm3, mm2

	paddw		mm1, [esi+104]
	punpcklbw	mm2, mm7		; [edi+24] low

	paddw		mm2, [esi+112]
	punpckhbw	mm3, mm7		; [edi+24] high

	paddw		mm3, [esi+120]
	packuswb	mm0, mm1

	packuswb	mm2, mm3

	movq		[edi], mm0

	movq		[edi+edx], mm2

	jmp		Done

; Not many opportunities for pairing here...

noadd:
	movq		mm7, mmx_0101010101010101

	lea			eax, [edx+edx*2]	; = edx * 3

	movq		mm0, [esi]
	psllq		mm7, 7		; = 8080808080808080h

	packsswb	mm0, [esi+8]

	movq		mm1, [esi+16]
	paddb		mm0, mm7

	packsswb	mm1, [esi+24]

	movq		mm2, [esi+32]
	paddb		mm1, mm7

	packsswb	mm2, [esi+40]

	movq		mm3, [esi+48]
	paddb		mm2, mm7

	packsswb	mm3, [esi+56]

	movq		[edi], mm0
	paddb		mm3, mm7

	movq		[edi+edx], mm1
	movq		[edi+edx*2], mm2
	movq		[edi+eax], mm3

	lea			edi, [edi+edx*4]

	movq		mm0, [esi+64]

	packsswb	mm0, [esi+72]

	movq		mm1, [esi+80]
	paddb		mm0, mm7

	packsswb	mm1, [esi+88]

	movq		mm2, [esi+96]
	paddb		mm1, mm7

	packsswb	mm2, [esi+104]

	movq		mm3, [esi+112]
	paddb		mm2, mm7

	packsswb	mm3, [esi+120]

	movq		[edi], mm0
	paddb		mm3, mm7

	movq		[edi+edx], mm1
	movq		[edi+edx*2], mm2
	movq		[edi+eax], mm3

Done:
	pop		edi
	pop		esi
	ret

mmx_Add_Block	ENDP

    ; mmx_form_component_prediction(
    ;   [esp+ 4]    void *src,		source of prediction
    ;   [esp+ 8]    void *dst,		destination for prediction
    ;   [esp+12]    int  lx,		stride (both src and dst)
    ;   [esp+16]    int  width,		width of block (8 or 16)
    ;   [esp+20]    int  height,	height of block (4, 8 or 16)
    ;   [esp+24]    int  dx,		bottom bit indicates half-pel
    ;   [esp+28]    int  dy,		bottom bit indicates half-pel
    ;   [esp+32]    int  avg		averaging flag (bottom 8 bits)
    ; );

	PUBLIC C isse_form_component_prediction
	PUBLIC C mmx_form_component_prediction

isse_form_component_prediction:
		mov		ISSE_allowed, 1
		jmp		form_component_prediction

mmx_form_component_prediction:
		mov		ISSE_allowed, 0

form_component_prediction	PROC C PRIVATE
		push	esi
		push	edi
		push	ebx
		push	ebp

		mov		esi, [esp+ 4+16]		; src
		mov		edi, [esp+ 8+16]		; dst

	; Jump offset is:	.....x..	(dx & 1)
	;					......x.	(dy & 1)
	;					.......x	!!avg

		mov		eax, [esp+24+16]	; dx
		mov		ebx, [esp+28+16]	; dy
		and		eax, 1
		and		ebx, 1
		add		ebx, ebx
		cmp		byte ptr [esp+32+16], 1	; avg
		lea		eax, [eax*4+ebx+1]
		sbb		eax, 0

	; These registers are common to every method
	; Note: width is always either 8 or 16
		mov		ebx, [esp+12+16]	; lx (stride)
		mov		ecx, [esp+16+16]	; width
		mov		ebp, [esp+20+16]	; height
		mov		edx, ebx
		sub		edx, ecx			; width-lx

		jmp		predtable[eax*4]

predtable	LABEL DWORD
	DWORD OFFSET pred_000, OFFSET pred_001
	DWORD OFFSET pred_010, OFFSET pred_011
	DWORD OFFSET pred_100, OFFSET pred_101
	DWORD OFFSET pred_110, OFFSET pred_111

; The following are equivalent:
;
; a)  result = (s1 + s2 + 1) >> 1;
; b)  result = (s1 >> 1) + (s2 >> 1) + ((s1 | s2) & 1);
;
; a)  result = (d + ((s1 + s2 + 1) >> 1) + 1) >> 1;
; b)  result = (s1 + s2 + d + d + 3) >> 2;
;
; a)  result = (d + ((s1 + s2 + s3 + s4 + 2) >> 2) + 1) >> 1;
; b)  result = (s1 + s2 + s3 + s4 + d + d + d + d + 6) >> 3;

; Actually, I'm now using the same algorithm Avery used:
; c)  result = (s1 | s2) - ((s1 ^ s2) >> 1);
; Even though it doesn't present as many opportunities
; for pairing, it does shave a few cycles off the loops!


; From Intel's documentation:
;
; "While the pavg instructions operate on two values at a time, it
; is possible to use three pavg instructions to approximate 4-value
; averaging. The line below illustrates this in pseudo-code:
;
;	Y = pavg(pavg(A,B),pavg(C,D)-1)
;
; This value is close to (A + B + C + D + 2)/4 which is the
; typical calculation used to perform subsampling. However, for
; the approximation, 87.5% of values match exactly, and 12.5% of
; the values are off by one least significant bit (LSbit). The
; maximum error is one LSbit. This error is often acceptable for
; performing motion estimation."

; Well, I don't accept it, so there's no pavgb code for
; the 2 cases of horizontal plus vertical half-pel here.
; (Avery's recommendation won't work here either.)
; Ref: see section 7.6.4 of ISO/IEC 13818-2


pred_111:	; horizontal and vertical half-pel, with averaging

; *dst = (src[x] + src[x+1] + src[x+lx2]
;  + src[x+lx2+1] + (*dst)<<2 + 6) >> 3

		movq		mm6, mmx_0006000600060006
		pxor		mm7, mm7

		align	16

loop0y:	mov			eax, ecx

loop0x:		movq		mm0, [esi]

			movq		mm2, [esi+1]
			movq		mm1, mm0

			movq		mm3, mm2
			punpcklbw	mm0, mm7	; mm0 = [esi] low

			movq		mm4, [ebx+esi]
			punpckhbw	mm1, mm7	; mm1 = [edi] high

			movq		mm5, mm4
			punpcklbw	mm2, mm7	; mm2 = [esi+1] low

			paddw		mm0, mm2	; mm0 = X low, mm2 free
			punpckhbw	mm3, mm7	; mm3 = [esi+1] high

			movq		mm2, [ebx+esi+1]
			punpcklbw	mm4, mm7	; mm4 = [ebx] low

			paddw		mm1, mm3	; mm1 = X high, mm3 free
			punpckhbw	mm5, mm7	; mm5 = [ebx] high

			movq		mm3, mm2
			punpcklbw	mm2, mm7	; mm2 = [ebx+1] low

			paddw		mm0, mm6	; mm0 = X low adjusted
			punpckhbw	mm3, mm7	; mm3 = [ebx+1] high

			paddw		mm2, mm4	; mm2 = Y low, mm4 free
			paddw		mm3, mm5	; mm3 = Y high, mm5 free

			movq		mm4, [edi]
			paddw		mm0, mm2	; mm0 = X+Y low, adjusted

			movq		mm5, mm4
			punpcklbw	mm4, mm7	; mm4 = dst low

			paddw		mm3, mm6	; mm3 = Y high, adjusted
			punpckhbw	mm5, mm7	; mm5 = dst high

			paddw		mm1, mm3	; mm1 = X+Y high, adjusted
			psllw		mm4, 2

			paddw		mm0, mm4
			psllw		mm5, 2

			paddw		mm1, mm5
			psrlw		mm0, 3

			psrlw		mm1, 3
			add			esi, 8

			packuswb	mm0, mm1
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop0x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop0y

		jmp		Done

pred_110:	; horizontal and vertical half-pel, no averaging

; *dst = (src[x] + src[x+1] + src[x+lx2] + src[x+lx2+1] + 2) >> 2

		movq		mm6, mmx_0002000200020002
		pxor		mm7, mm7

		align	16

loop1y:	mov		eax, ecx

loop1x:		movq		mm0, [esi]

			movq		mm2, [esi+1]
			movq		mm1, mm0

			movq		mm3, mm2
			punpcklbw	mm0, mm7		; [esi] low

			paddw		mm0, mm6
			punpckhbw	mm1, mm7		; [esi] high

			paddw		mm1, mm6
			punpcklbw	mm2, mm7		; [esi+1] low

			paddw		mm0, mm2
			punpckhbw	mm3, mm7		; [esi+1] high

			movq		mm2, [ebx+esi]
			paddw		mm1, mm3

			movq		mm3, mm2
			punpcklbw	mm2, mm7		; [ebx] low

			paddw		mm0, mm2
			punpckhbw	mm3, mm7

			movq		mm2, [ebx+esi+1]
			paddw		mm1, mm3

			movq		mm3, mm2
			punpcklbw	mm2, mm7		; [ebx+1] low

			paddw		mm0, mm2
			punpckhbw	mm3, mm7		; [ebx+1] high

			paddw		mm1, mm3
			psrlw		mm0, 2

			psrlw		mm1, 2
			add			esi, 8

			packuswb	mm0, mm1
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop1x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop1y

		jmp		Done

pred_101:	; horizontal but no vertical half-pel, with averaging

; *dst = ((src[x] + src[x+1] + (*dst) + (*dst) + 3) >> 2

		cmp		ISSE_allowed, 0
		jne		isseloop2y

		movq	mm7, mmx_7F7F7F7F7F7F7F7F

		align	16

loop2y:	mov			eax, ecx

loop2x:		movq		mm0, [esi]

			movq		mm2, [esi+1]
			movq		mm1, mm0

			pxor		mm0, mm2
			por			mm1, mm2

			movq		mm2, [edi]
			psrlq		mm0, 1

			pand		mm0, mm7	; 7F7F7F7F7F7F7F7F

			psubb		mm1, mm0	; mm1 done, mm0 free

			movq		mm0, mm1
			pxor		mm1, mm2

			por			mm0, mm2
			psrlq		mm1, 1

			pand		mm1, mm7	; 7F7F7F7F7F7F7F7F
			add			esi, 8

			psubb		mm0, mm1
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop2x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop2y

		jmp		Done

		align	16

isseloop2y:
		mov		eax, ecx

isseloop2x:	movq		mm0, [esi]

			pavgb		mm0, [esi+1]

			pavgb		mm0, [edi]

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			isseloop2x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		isseloop2y

		jmp		Done

pred_100:	; horizontal but no vertical half-pel, no averaging

		cmp		ISSE_allowed, 0
		jne		isseloop3y

; There are at least 3 ways to do this:
; *dst = ((src[x] + src[x+1] + 1) >> 1;
; *dst = (src[x] >> 1) + (src[x+1] >> 1) + ((src[x] | src[x+1]) & 1);
; *dst = (src[x] | src[x+1]) - ((src[x] ^ src[x+1]) >> 1);

		movq		mm7, mmx_7F7F7F7F7F7F7F7F

		align	16

loop3y:	mov			eax, ecx

; *dst = (src[x] | src[x+1]) - ((src[x] ^ src[x+1]) >> 1);

loop3x:		movq		mm0, [esi]

			movq		mm1, [esi+1]
			movq		mm2, mm0

			pxor		mm2, mm1
			por			mm0, mm1

			psrlq		mm2, 1

			pand		mm2, mm7	; 7F7F7F7F7F7F7F7F
			add			esi, 8

			psubb		mm0, mm2
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop3x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop3y

		jmp		Done

		align	16

isseloop3y:
		mov		eax, ecx

isseloop3x:	movq		mm0, [esi]

			pavgb		mm0, [esi+1]

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			isseloop3x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		isseloop3y

		jmp		Done

pred_011:	; no horizontal but vertical half-pel, with averaging

		cmp		ISSE_allowed, 0
		jne		isseloop4y

		movq		mm7, mmx_7F7F7F7F7F7F7F7F

		align	16

loop4y:	mov			eax, ecx

loop4x:		movq		mm0, [esi]

			movq		mm2, [ebx+esi]
			movq		mm1, mm0

			pxor		mm0, mm2
			por			mm1, mm2

			movq		mm2, [edi]
			psrlq		mm0, 1

			pand		mm0, mm7	; 7F7F7F7F7F7F7F7F

			psubb		mm1, mm0	; mm1 done, mm0 free

			movq		mm0, mm1
			pxor		mm1, mm2

			por			mm0, mm2
			psrlq		mm1, 1

			pand		mm1, mm7	; 7F7F7F7F7F7F7F7F
			add			esi, 8

			psubb		mm0, mm1
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop4x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop4y

		jmp		Done

		align	16

isseloop4y:
		mov		eax, ecx

isseloop4x:	movq		mm0, [esi]

			pavgb		mm0, [ebx+esi]

			pavgb		mm0, [edi]

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			isseloop4x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		isseloop4y

		jmp		Done

pred_010:	; no horizontal but vertical half-pel, no averaging

		cmp		ISSE_allowed, 0
		jne		isseloop5y

		movq		mm7, mmx_7F7F7F7F7F7F7F7F

		align	16

loop5y:	mov			eax, ecx

loop5x:		movq		mm0, [esi]

			movq		mm1, [ebx+esi]
			movq		mm2, mm0

			pxor		mm2, mm1
			por			mm0, mm1

			psrlq		mm2, 1

			pand		mm2, mm7	; 7F7F7F7F7F7F7F7F
			add			esi, 8

			psubb		mm0, mm2
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop5x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop5y

		jmp		Done

		align	16

isseloop5y:
		mov		eax, ecx

isseloop5x:	movq		mm0, [esi]

			pavgb		mm0, [ebx+esi]

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			isseloop5x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		isseloop5y

		jmp		Done

pred_001:	; no norizontal nor vertical half-pel, with averaging

		cmp		ISSE_allowed, 0
		jne		isseloop6y

		movq		mm7, mmx_7F7F7F7F7F7F7F7F

		align	16

loop6y:	mov			eax, ecx

loop6x:		movq		mm0, [esi]

			movq		mm1, [edi]
			movq		mm2, mm0

			pxor		mm2, mm1
			por			mm0, mm1

			psrlq		mm2, 1

			pand		mm2, mm7	; 7F7F7F7F7F7F7F7F
			add			esi, 8

			psubb		mm0, mm2
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop6x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop6y

		jmp		Done

		align	16

isseloop6y:
		mov		eax, ecx

isseloop6x:	movq		mm0, [esi]

			pavgb		mm0, [edi]

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			isseloop6x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		isseloop6y

		jmp		Done

pred_000:	; no horizontal nor vertical half-pel, no averaging

		align	16

loop7y:	mov		eax, ecx

loop7x:		movq		mm0, [esi]

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0

			lea			edi, [edi+8]
			jg			loop7x

		add		esi, edx
		add		edi, edx
		dec		ebp
		jg		loop7y

Done:	pop		ebp
		pop		ebx
		pop		edi
		pop		esi
		ret

form_component_prediction	ENDP

    ; mmx_conv420to422(
    ;   [esp+ 4]    void *src,
    ;   [esp+ 8]    void *dst,
    ;   [esp+12]    int  width,
    ;   [esp+16]    int  height,
    ;   [esp+20]    bool progressive
    ; );

	PUBLIC C	isse_conv420to422
	PUBLIC C	mmx_conv420to422

	; WARNING !!!!!!!!!!!!!!!
	; "progressive" is declared as bool in C++,
	; therefore its upper 24 bits are undefined!

isse_conv420to422:
	mov		ISSE_allowed, 1
	jmp		conv420to422

mmx_conv420to422:
	mov		ISSE_allowed, 0

conv420to422	PROC C PUBLIC

	push	esi
	push	edi
	mov		esi, [esp+ 4+ 8]	; src
	push	ebx
	mov		edi, [esp+ 8+12]	; dst
	push	ebp

	cmp		byte ptr [esp+20+16], 0		; progressive?
	je		interlaced

; Progressive MPEG-1 or MPEG-2:
    ; The chroma is subsampled in the middle:
    ; MPEG-1          MPEG-2
    ;   Y . Y . Y       Y . Y . Y
    ;   . C . C .       C . C . C
    ;   Y . Y . Y       Y . Y . Y
    ; Therefore it should contain 50% of the real
	; chroma above it and 50% of the chroma below

    ; dst[0] = (src + src-1 + 1) >> 1;
    ; dst[w] = (src + src+1 + 1) >> 1;

    movq    mm6, mmx_0101010101010101
    movq    mm7, mmx_7F7F7F7F7F7F7F7F

    dec     dword ptr [esp+16+16]   ; height
    xor     ebp, ebp
    mov     ebx, [esp+12+16]    ; width (permanent)

	cmp		ISSE_allowed, 0
	jne		sseyloop1

	align	16

yloop1:
		xor		ecx, ecx			; sm1 (src minus 1)
		xor		edx, edx			; sp1 (src plus 1)

    ; The following branches fall through for all iterations but two
		.IF (SDWORD PTR ebp > SDWORD PTR ecx)
			sub		ecx, ebx		; (sm1 points to a previous line)
		.ENDIF
		.IF (SDWORD PTR ebp < SDWORD PTR [esp+16+16])	; height-1
			add		edx, ebx		; (sp1 points to the next line)
		.ENDIF
		mov     eax, ebx

		align 16

; This is implemented as:
; result1 = (src >> 1) + (sm1 >> 1) + ((src | sm1) & 1);
; result2 = (src >> 1) + (sp1 >> 1) + ((src | sp1) & 1);

xloop1:		movq		mm0, [esi]		; src

            movq        mm3, [esi+ecx]  ; sm1
            movq        mm1, mm0

            movq        mm2, mm1        ; mm0, mm1, mm2 = src
            por         mm1, mm3        ; mm1 = (src | sm1)

            pand        mm1, mm6        ; 0101010101010101
            psrlq       mm2, 1          ; mm2 = (src >> 1)

            pand        mm2, mm7        ; 7F7F7F7F7F7F7F7F
            psrlq       mm3, 1          ; mm3 = (sm1 >> 1)

            movq        mm4, [esi+edx]  ; sp1
            pand        mm3, mm7        ; 7F7F7F7F7F7F7F7F

            paddb       mm1, mm3
            movq        mm3, mm4

            paddb       mm1, mm2        ; * result 1 finished *
            psrlq       mm4, 1

            por         mm3, mm0        ; mm3 = (src | sp1)
            pand        mm4, mm7        ; 7F7F7F7F7F7F7F7F

            paddb       mm4, mm2
            pand        mm3, mm6        ; 0101010101010101

            movq        [edi], mm1
            paddb       mm4, mm3        ; * result 2 finished *

            add         esi, 8
            sub         eax, 8

            movq        [edi+ebx], mm4

            lea         edi, [edi+8]
            jg          xloop1

		inc		ebp
		add		edi, ebx
		cmp		ebp, [esp+16+16]	; height-1
		jle		yloop1

	jmp		Done


; We can use "pavgb" if ISSE is available...

	align	16

sseyloop1:
		xor		ecx, ecx			; sm1 (src minus 1)
		xor		edx, edx			; sp1 (src plus 1)

    ; The following branches fall through for all iterations but two
		.IF (SDWORD PTR ebp > SDWORD PTR ecx)
			sub		ecx, ebx		; (sm1 points to a previous line)
		.ENDIF
		.IF (SDWORD PTR ebp < SDWORD PTR [esp+16+16])	; height-1
			add		edx, ebx		; (sp1 points to the next line)
		.ENDIF
		mov     eax, ebx

		align 16

ssexloop1:	movq		mm0, [esi]		; src

			movq		mm2, [esi+ecx]	; sm1
            movq        mm1, mm0

			pavgb		mm1, [esi+edx]	; mm1 = avg with sp1
			pavgb		mm0, mm2		; mm0 = avg with sm1

			add			esi, 8
			sub			eax, 8

			movq		[edi], mm0
            movq        [edi+ebx], mm1

            lea         edi, [edi+8]
            jg          ssexloop1

		inc		ebp
		add		edi, ebx
		cmp		ebp, [esp+16+16]	; height-1
		jle		sseyloop1

	jmp		Done


interlaced:

	pxor		mm7, mm7
	mov			eax, 00040004h
	movd		mm6, eax
	shr			dword ptr [esp+16+16], 1	; height
	punpckldq	mm6, mm6
	dec			dword ptr [esp+16+16]
	xor			ebp, ebp

    mov         ebx, [esp+12+16]    ; width
    add         ebx, ebx            ; * 2 (permanent)

	align	16

yloop2:
        xor     ecx, ecx            ; sm1 (src minus 1)
        xor     edx, edx            ; sp1 (src plus 1)

		.IF (SDWORD PTR ebp > SDWORD PTR ecx)
			sub		ecx, ebx
		.ENDIF
		.IF (SDWORD PTR ebp < SDWORD PTR [esp+16+16])	; height-1
			add		edx, ebx
		.ENDIF
		mov     eax, ebx

		align 16

	; top field:
	; dst[0]   = (src*7 + sm1   + 4) >> 3;
	; dst[w*2] = (src*5 + sp1*3 + 4) >> 3;

xloopt:		movq		mm0, [esi]		; src

            movq        mm2, [esi+ecx]  ; sm1
			movq		mm1, mm0		; copy of src

            movq        mm3, mm2		; copy of sm1
			punpcklbw	mm0, mm7		; src low

			movq		mm4, mm0		; copy of src low
			punpckhbw	mm1, mm7		; src high

			movq		mm5, mm1		; copy of src high
            psllw       mm4, 3

			psubw		mm4, mm0		; mm4 = src low * 7
            psllw       mm5, 3

			psubw		mm5, mm1		; mm5 = src high * 7
			punpcklbw	mm2, mm7		; sm1 low

            paddw       mm2, mm4        ; mm2 = (src low * 7) + sm1 low
			punpckhbw	mm3, mm7		; sm1 high
			
            paddw       mm3, mm5        ; mm3 = (src high * 7) + sm1 high
            movq        mm4, mm0        ; copy (again) src low

			paddw		mm2, mm6
            movq        mm5, mm1        ; copy (again) src high

			paddw		mm3, mm6
            psllw       mm4, 2

			paddw		mm4, mm0		; mm4 = src low * 5
			psllw		mm5, 2

			paddw		mm5, mm1		; mm5 = src high * 5
            psrlw       mm2, 3          ; * dst low finished *

            movq        mm0, [esi+edx]  ; sp1
			psrlw		mm3, 3			; * dst high finished *

			movq		mm1, mm0		; copy of sp1
			punpcklbw	mm0, mm7		; sp1 low

			paddw		mm4, mm0		; (src low * 5) + sp1 low
			punpckhbw	mm1, mm7		; sp1 high

			paddw		mm4, mm0		; (src low * 5) + (sp1 low * 2)
			paddw		mm5, mm1		; (src high * 5) + sp1 high

			paddw		mm4, mm0		; (src low * 5) + (sp1 low * 3)
			paddw		mm5, mm1		; (src high * 5) + (sp1 high * 2)

			paddw		mm4, mm6		; (src low * 5) + (sp1 low * 3) + 4
			paddw		mm5, mm1		; (src high * 5) + (sp1 high * 3)

			paddw		mm5, mm6		; (src high * 5) + (sp1 high * 3) + 4
			psrlw		mm4, 3

			packuswb	mm2, mm3		; ** dst finished **
			add			esi, 8

			movq		[edi], mm2
			psrlw		mm5, 3

			packuswb	mm4, mm5
			sub			eax, 16

			movq		[edi+ebx], mm4

			lea			edi, [edi+8]
            jg          xloopt

    ; Bottom field
		mov     eax, ebx

		align 16

	; bottom field:
	; dst[0]   = (src*5 + sm1*3 + 4) >> 3;
	; dst[w*2] = (src*7 + sp1   + 4) >> 3;

xloopb:		movq		mm0, [esi]		; src

            movq        mm2, [esi+edx]  ; sp1
			movq		mm1, mm0

            movq        mm3, mm2
			punpcklbw	mm0, mm7		; src low

			movq		mm4, mm0		; copy of src low
			punpckhbw	mm1, mm7		; src high

			movq		mm5, mm1		; copy of src high
            psllw       mm4, 3

			psubw		mm4, mm0		; mm4 = src low * 7
            psllw       mm5, 3

			psubw		mm5, mm1		; mm5 = src high * 7
			punpcklbw	mm2, mm7		; sm1 low

            paddw       mm2, mm4        ; mm2 = (src low * 7) + sp1 low
			punpckhbw	mm3, mm7		; sm1 high
			
            paddw       mm3, mm5        ; mm3 = (src high * 7) + sp1 high
            movq        mm4, mm0        ; copy (again) src low

			paddw		mm2, mm6
            movq        mm5, mm1        ; copy (again) src high

			paddw		mm3, mm6
            psllw       mm4, 2

			paddw		mm4, mm0		; mm4 = src low * 5
			psllw		mm5, 2

			paddw		mm5, mm1		; mm5 = src high * 5
            psrlw       mm2, 3          ; * dst low finished *

            movq        mm0, [esi+ecx]  ; sm1
			psrlw		mm3, 3			; * dst high finished *

			movq		mm1, mm0
			punpcklbw	mm0, mm7		; sm1 low

			paddw		mm4, mm0
			punpckhbw	mm1, mm7		; sm1 high

			paddw		mm4, mm0
			paddw		mm5, mm1

			paddw		mm4, mm0
			paddw		mm5, mm1

			paddw		mm4, mm6
			paddw		mm5, mm1

			paddw		mm5, mm6
			psrlw		mm4, 3

			packuswb	mm2, mm3		; ** dst finished **
			add			esi, 8

			movq		[edi+ebx], mm2
			psrlw		mm5, 3

			packuswb	mm4, mm5
			sub			eax, 16

			movq		[edi], mm4

			lea			edi, [edi+8]
            jg          xloopb

		inc		ebp
        add     edi, ebx
		cmp		ebp, [esp+16+16]	; height-1
		jle		yloop2

Done:	pop		ebp
		pop		ebx
		pop		edi
		pop		esi
		ret

conv420to422	ENDP

    ; mmx_conv422to444(
    ;   [esp+ 4]    void *src,
    ;   [esp+ 8]    void *dst,
    ;   [esp+12]    int  width,
    ;   [esp+16]    int  height,
    ;   [esp+20]    int  mpeg2
    ; );

	PUBLIC C	isse_conv422to444
	PUBLIC C	mmx_conv422to444

isse_conv422to444:
	mov		ISSE_allowed, 1
	jmp		conv422to444

mmx_conv422to444:
	mov		ISSE_allowed, 0

conv422to444	PROC C PUBLIC

	push	esi
	push	edi
	mov		esi, [esp+ 4+8]		; src
	mov		edi, [esp+ 8+8]		; dst

	cmp		dword ptr [esp+20+8], 0		; MPEG-2?
	jnz		Mpeg2

    ; MPEG-1
    ;   Y . Y . Y
    ;   . C . C .
    ;   Y . Y . Y

    movq    mm6, mmx_0101010101010101
    movq    mm7, mmx_7F7F7F7F7F7F7F7F

	mov		ecx, [esp+16+8]		; height

	cmp		ISSE_allowed, 0
	jne		sseyloop1

	align	16

yloop1:
	movq		mm1, [esi]		; current

; For the first pass, the top byte of prev is the same
; as the first byte of the current row; i.e: 65432100

	movq		mm2, mm1
	psllq		mm1, 56

	mov			eax, [esp+12+8]		; width
	add			esi, 8
	sub			eax, 8

	align	16

xloop1:
		movq		mm0, mm1		; mm0 = prev	(6543210.)
		movq		mm3, mm2		; mm1 = current (76543210)

		movq		mm2, [esi]		; mm2 = next	(.7654321)
		psrlq		mm0, 56			; .......x (top byte of prev row)

		movq		mm1, mm3		; current
		psllq		mm3, 8

		movq		mm4, mm1
		por			mm0, mm3		; 6543210x

	; Now, produce the average of mm0 and mm4 (OK to destroy both)
		movq		mm3, mm4
		psrlq		mm4, 1

		por			mm3, mm0
		psrlq		mm0, 1

		pand		mm3, mm6		; 0101010101010101
		pand		mm0, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm0, mm3
		pand		mm4, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm0, mm4		; * done *
; Now produce the average of current and next
		movq		mm3, mm1	; current

		movq		mm4, mm2	; next
		psrlq		mm3, 8		; .7654321

		movq		mm5, mm1	; current
		psllq		mm4, 56		; x.......

		por			mm3, mm4
		psrlq		mm5, 1

		movq		mm4, mm3
		psrlq		mm3, 1

		por			mm4, mm1
		pand		mm5, mm7	; 7F7F7F7F7F7F7F7F

		pand		mm4, mm6	; 0101010101010101
		pand		mm3, mm7	; 7F7F7F7F7F7F7F7F

		paddb		mm3, mm4
		movq		mm4, mm0

		paddb		mm3, mm5	; * done *

		punpcklbw	mm4, mm3	; cn cp cn cp cn cp cn cp (dst0)

		punpckhbw	mm0, mm3	; cn cp cn cp cn cp cn cp (dst1)

		add			esi, 8
		sub			eax, 8

		movq		[edi], mm4

		movq		[edi+8], mm0

		lea		edi, [edi+16]
		jg		xloop1

	; The last row needs special handling...
		movq		mm0, mm1		; mm0 = prev	(6543210.)
		movq		mm3, mm2		; mm1 = current (76543210)

		movq		mm4, mm3
		psrlq		mm0, 56

		movq		mm1, mm3
		psllq		mm3, 8

		por			mm0, mm3
		psrlq		mm2, 56

	; Now, produce the average of mm0 and mm4 (OK to destroy both)
		movq		mm3, mm4
		psrlq		mm4, 1

		por			mm3, mm0
		psrlq		mm0, 1

		pand		mm3, mm6		; 0101010101010101
		pand		mm0, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm0, mm3
		pand		mm4, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm0, mm4		; * done *
; Now produce the average of current and next
		movq		mm3, mm1	; current

		movq		mm4, mm2	; next
		psrlq		mm3, 8		; .7654321

		movq		mm5, mm1	; current
		psllq		mm4, 56		; x.......

		por			mm3, mm4
		psrlq		mm5, 1

		movq		mm4, mm3
		psrlq		mm3, 1

		por			mm4, mm1
		pand		mm5, mm7	; 7F7F7F7F7F7F7F7F

		pand		mm4, mm6	; 0101010101010101
		pand		mm3, mm7	; 7F7F7F7F7F7F7F7F

		paddb		mm3, mm4
		movq		mm4, mm0

		paddb		mm3, mm5	; * done *

		punpcklbw	mm4, mm3	; cn cp cn cp cn cp cn cp (dst0)

		punpckhbw	mm0, mm3	; cn cp cn cp cn cp cn cp (dst1)
		dec			ecx

		movq		[edi], mm4
		movq		[edi+8], mm0

		lea		edi, [edi+16]
		jg		yloop1

	jmp		Done


; We can use "pavgb" if ISSE is available...

	align	16

sseyloop1:
	movq		mm1, [esi]		; current

; For the first pass, the top byte of prev is the same
; as the first byte of the current row; i.e: 65432100

	movq		mm2, mm1
	psllq		mm1, 56

	mov			eax, [esp+12+8]		; width
	add			esi, 8
	sub			eax, 8

	align	16

ssexloop1:
	; We want:
	;	(prev >> 56) | (current << 8) = 6543210x
	;	average that with current (OK to destroy prev)
	; Then:
	;	(next << 56) | (current >> 8) = x7654321
	;	average that with current

		movq		mm0, mm1		; mm0 = prev	(6543210.)
		movq		mm3, mm2		; mm1 = current (76543210)

		movq		mm2, [esi]		; mm2 = next	(.7654321)
		psrlq		mm0, 56			; .......x (top byte of prev row)

		movq		mm1, mm3		; mm3 is a copy of "current" (mm1)
		psllq		mm3, 8

	; Average "prev" and "next" (OK to destroy "prev")
		por			mm0, mm3		; (6543210x)
		movq		mm3, mm1		; mm3 is a copy of "current" (mm1)

		pavgb		mm0, mm1		; (* done *)
		movq		mm4, mm2		; mm4 is a copy of "next" (mm2)

		psrlq		mm3, 8			; .7654321
		psllq		mm4, 56			; x.......

		por			mm3, mm4		; x7654321
		movq		mm4, mm0

		pavgb		mm3, mm1		; (* done *)

		punpcklbw	mm4, mm3	; cn cp cn cp cn cp cn cp (dst0)
		add			esi, 8

		punpckhbw	mm0, mm3	; cn cp cn cp cn cp cn cp (dst1)
		sub			eax, 8

		movq		[edi], mm4

		movq		[edi+8], mm0

		lea		edi, [edi+16]
		jg		ssexloop1

	; The last column needs special handling...
		movq		mm0, mm1	; mm0 = prev	(6543210.)
		movq		mm3, mm2	; mm1 = current (76543210)

		movq		mm4, mm3
		psrlq		mm0, 56

		movq		mm1, mm3	; mm3 is a copy of "current" (mm1)
		psllq		mm3, 8

		por			mm0, mm3
		psrlq		mm2, 56

		pavgb		mm0, mm1
		psllq		mm2, 56		; x.......

		movq		mm3, mm1	; mm3 is a copy of "current" (mm1)
		psrlq		mm3, 8		; .7654321

		por			mm2, mm3	; x7654321

		pavgb		mm2, mm1
		movq		mm3, mm0

		punpcklbw	mm3, mm2	; cn cp cn cp cn cp cn cp (dst0)

		punpckhbw	mm0, mm2	; cn cp cn cp cn cp cn cp (dst1)
		dec			ecx

		movq		[edi], mm3
		movq		[edi+8], mm0

		lea		edi, [edi+16]
		jg		sseyloop1

	jmp		Done


Mpeg2:
    ; MPEG-2
    ;   Y . Y . Y
    ;   C . C . C
    ;   Y . Y . Y

    movq    mm6, mmx_0101010101010101
	pcmpeqd	mm5, mm5		; FFFFFFFFFFFFFFFF
    movq    mm7, mmx_7F7F7F7F7F7F7F7F
	psllq	mm5, 56			; FF00000000000000

	mov		ecx, [esp+16+8]		; height

	cmp		ISSE_allowed, 0
	jne		sseyloop2			; use "pavgb"

	align	16

yloop2:
	movq		mm1, [esi]
	add			esi, 8
	mov			eax, [esp+12+8]		; width
	sub			eax, 8

	; let mm0 = 76543210
	; let mm1 = FEDCBA98
	align	16

xloop2:
		movq		mm0, mm1		; prev = current
		movq		mm2, mm1		; mm2 = current

		movq		mm3, [esi]		; fetch next
		psrlq		mm2, 8			; .7654321

		movq		mm1, mm3		; current = next (for next pass)
		psllq		mm3, 56			; 8.......

		por			mm3, mm2		; mm3 = 87654321
		movq		mm2, mm0		; mm2 = 76543210

	; Now, produce the average of mm2 and mm3
		movq		mm4, mm2
		psrlq		mm2, 1

		por			mm4, mm3
		psrlq		mm3, 1

		pand		mm4, mm6		; 0101010101010101
		pand		mm2, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm2, mm4
		pand		mm3, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm2, mm3		; done (mm2 = average)
		movq		mm3, mm0		; 76543210

	; Interleave
		movq		mm4, mm0
		punpcklbw	mm3, mm2		; .3.2.1.0

		punpckhbw	mm4, mm2		; .7.6.5.4
		add			esi, 8

		sub			eax, 8

		movq		[edi], mm3
		movq		[edi+8], mm4

		lea			edi, [edi+16]
		jg			xloop2

	; The final byte of each row needs special handling
		movq		mm3, mm1
		psrlq		mm1, 8			; .7654321

		movq		mm0, mm3		; mm0 = current
		pand		mm3, mm5		; FF00000000000000

		movq		mm2, mm0		; mm0 = 76543210
		por			mm3, mm1		; mm3 = 77654321

	; Now, produce the average of mm2 and mm3
		movq		mm4, mm2
		psrlq		mm2, 1

		por			mm4, mm3
		psrlq		mm3, 1

		pand		mm4, mm6		; 0101010101010101
		pand		mm2, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm2, mm4
		pand		mm3, mm7		; 7F7F7F7F7F7F7F7F

		paddb		mm2, mm3		; done (mm2 = average)
		movq		mm3, mm0		; 76543210

	; Interleave
		movq		mm4, mm0
		punpcklbw	mm3, mm2		; .3.2.1.0

		punpckhbw	mm4, mm2		; .7.6.5.4
		dec			ecx

		movq		[edi], mm3
		movq		[edi+8], mm4

		lea		edi, [edi+16]
		jg		yloop2

	jmp		Done


; We can use "pavgb" if ISSE is available...

	align	16

sseyloop2:
	movq		mm1, [esi]
	add			esi, 8
	mov			eax, [esp+12+8]		; width
	sub			eax, 8

	align	16

ssexloop2:
	; Produce (current >> 8) | (next << 56)
		movq		mm0, mm1		; mm0 = current
		movq		mm2, mm1		; 76543210

		movq		mm3, [esi]		; mm1 = next
		psrlq		mm2, 8			; .7654321

		movq		mm1, mm3		; mm3 is a copy of "next" (mm1)
		psllq		mm3, 56			; 8.......

		por			mm2, mm3		; mm2 = 87654321
		movq		mm3, mm0

		pavgb		mm2, mm0

	; Interleave
		punpcklbw	mm0, mm2		; .3.2.1.0
		add			esi, 8

		punpckhbw	mm3, mm2		; .7.6.5.4
		sub			eax, 8

		movq		[edi], mm0
		movq		[edi+8], mm3

		lea			edi, [edi+16]
		jg			ssexloop2

	; The final byte of each row needs special handling
		movq		mm3, mm1
		psrlq		mm1, 8			; .7654321

		movq		mm0, mm3		; mm0 = current
		pand		mm3, mm5		; FF00000000000000

		movq		mm2, mm0		; mm0 = 76543210
		por			mm3, mm1		; mm3 = 77654321

	; Now, produce the average of mm2 and mm3
		pavgb		mm2, mm3
		movq		mm3, mm0		; 76543210

	; Interleave
		punpcklbw	mm0, mm2		; .3.2.1.0

		punpckhbw	mm3, mm2		; .7.6.5.4
		dec			ecx

		movq		[edi], mm0
		movq		[edi+8], mm3

		lea		edi, [edi+16]
		jg		sseyloop2


Done:	pop		edi
		pop		esi
		ret

conv422to444	ENDP


    ; mmx_conv422toYUY2(
    ;   [esp+ 4]    void *srcY,
    ;   [esp+ 8]    void *srcU,
	;	[esp+12]	void *srcV,
	;	[esp+16]	void *dst,
    ;   [esp+20]    int  width,
    ;   [esp+24]    int  height
    ; );

mmx_conv422toYUY2	PROC C PUBLIC

	push	esi
	push	edi
	push	ebx
	mov		esi, [esp+ 4+12]	; srcY
	mov		ecx, [esp+ 8+12]	; srcU
	mov		edx, [esp+12+12]	; srcV
	mov		edi, [esp+16+12]	; dst
	mov		ebx, [esp+24+12]	; height

yloop:
		mov			eax, [esp+20+12]	; width

	; bias pointers
		lea			esi, [esi+eax*2]
		add			ecx, eax
		lea			edi, [edi+eax*4]
		add			edx, eax

		neg			eax

		align	16
xloop:
		movq		mm2, [ecx+eax]		; U7 U6 U5 U4 U3 U2 U1 U0

		movq		mm3, [edx+eax]		; V7 V6 V5 V4 V3 V2 V1 V0
		movq		mm4, mm2			; U7 U6 U5 U4 U3 U2 U1 U0

		movq		mm5, [esi+eax*2]	; Y7 Y6 Y5 Y4 Y3 Y2 Y1 Y0
		punpcklbw	mm4, mm3			; V3 U3 V2 U2 V1 U1 V0 U0

		movq		mm0, mm5			; Y7 Y6 Y5 Y4 Y3 Y2 Y1 Y0
		punpcklbw	mm5, mm4			; V1 Y3 U1 Y2 V0 Y1 U0 Y0 (dst0)

		movq		mm1, [esi+eax*2+8]	; YF YE YD YC YB YA Y9 Y8
		punpckhbw	mm0, mm4			; V3 Y7 U3 Y6 V2 Y5 U2 Y4 (dst1)

		movq		[edi+eax*4], mm5
		punpckhbw	mm2, mm3			; V7 U7 V6 U6 V5 U5 V4 U4

		movq		mm4, mm1			; YF YE YD YC YB YA Y9 Y8
		punpcklbw	mm1, mm2			; V5 YB U5 YA V4 Y9 U4 Y8 (dst2)

		movq		[edi+eax*4+8], mm0
		punpckhbw	mm4, mm2			; V7 YF U7 YE V6 YD U6 YC (dst3)

		movq		[edi+eax*4+16], mm1

		movq		[edi+eax*4+24], mm4

		add			eax, 8
		jl			xloop

		dec			ebx
		jg			yloop

		pop		ebx
		pop		edi
		pop		esi
		ret

mmx_conv422toYUY2	ENDP


    ; mmx_conv422toUYVY(
    ;   [esp+ 4]    void *srcY,
    ;   [esp+ 8]    void *srcU,
	;	[esp+12]	void *srcV,
	;	[esp+16]	void *dst,
    ;   [esp+20]    int  width,
    ;   [esp+24]    int  height
    ; );

mmx_conv422toUYVY	PROC C PUBLIC

	push	esi
	push	edi
	push	ebx
	mov		esi, [esp+ 4+12]	; srcY
	mov		ecx, [esp+ 8+12]	; srcU
	mov		edx, [esp+12+12]	; srcV
	mov		edi, [esp+16+12]	; dst
	mov		ebx, [esp+24+12]	; height

yloop:
		mov			eax, [esp+20+12]	; width

	; bias pointers
		lea			esi, [esi+eax*2]
		add			ecx, eax
		lea			edi, [edi+eax*4]
		add			edx, eax

		neg			eax

		align	16
xloop:
		movq		mm2, [ecx+eax]		; U7 U6 U5 U4 U3 U2 U1 U0

		movq		mm3, [edx+eax]		; V7 V6 V5 V4 V3 V2 V1 V0
		movq		mm4, mm2			; U7 U6 U5 U4 U3 U2 U1 U0

		movq		mm0, [esi+eax*2]	; Y7 Y6 Y5 Y4 Y3 Y2 Y1 Y0
		punpcklbw	mm4, mm3			; V3 U3 V2 U2 V1 U1 V0 U0

		movq		mm5, mm4			; V3 U3 V2 U2 V1 U1 V0 U0
		punpcklbw	mm4, mm0			; Y3 V1 Y2 U1 Y1 V0 Y0 U0 (dst0)

		movq		mm1, [esi+eax*2+8]	; YF YE YD YC YB YA Y9 Y8
		punpckhbw	mm5, mm0			; Y7 V3 Y6 U3 Y5 V2 Y4 U2 (dst1)

		movq		[edi+eax*4], mm4
		punpckhbw	mm2, mm3			; V7 U7 V6 U6 V5 U5 V4 U4

		movq		mm4, mm2			; V7 U7 V6 U6 V5 U5 V4 U4
		punpcklbw	mm2, mm1			; YB V5 YA U5 Y9 V4 Y8 U4 (dst2)

		movq		[edi+eax*4+8], mm5
		punpckhbw	mm4, mm1			; YF V7 YE U7 YD V6 YC U6 (dst3)

		movq		[edi+eax*4+16], mm2

		movq		[edi+eax*4+24], mm4

		add			eax, 8
		jl			xloop

		dec			ebx
		jg			yloop

		pop		ebx
		pop		edi
		pop		esi
		ret

mmx_conv422toUYVY	ENDP

        END
