//	This version has been modified by fccHandler, October 2005

#ifndef f_WMVTYPES_H
#define f_WMVTYPES_H

// This is technically ASF 2.0 (never seen one yet)

const GUID GUID_ASF2_Header_Object =
	{0xD6E229D1, 0x35DA, 0x11D1, {0x90, 0x34, 0x00, 0xA0, 0xC9, 0x03, 0x49, 0xBE}};

// The rest are based on revision 1.20.03, December 2004

const GUID GUID_ASF_Header_Object =
	{0x75B22630, 0x668E, 0x11CF, {0xA6, 0xD9, 0x00, 0xAA, 0x00, 0x62, 0xCE, 0x6C}};

const GUID GUID_ASF_File_Properties_Object =
	{0x8CABDCA1, 0xA947, 0x11CF, {0x8E, 0xE4, 0x00, 0xC0, 0x0C, 0x20, 0x53, 0x65}};

const GUID GUID_ASF_Content_Description_Object =
	{0x75B22633, 0x668E, 0x11CF, {0xA6, 0xD9, 0x00, 0xAA, 0x00, 0x62, 0xCE, 0x6C}};

const GUID GUID_ASF_Stream_Properties_Object =
	{0xB7DC0791, 0xA9B7, 0x11CF, {0x8E, 0xE6, 0x00, 0xC0, 0x0C, 0x20, 0x53, 0x65}};

const GUID GUID_ASF_Header_Extension_Object = 
	{0x5FBF03B5, 0xA92E, 0x11CF, {0x8E, 0xE3, 0x00, 0xC0, 0x0C, 0x20, 0x53, 0x65}};

const GUID GUID_ASF_Extended_Stream_Properties_Object =
	{0x14E6A5CB, 0xC672, 0x4332, {0x83, 0x99, 0xA9, 0x69, 0x52, 0x06, 0x5B, 0x5A}};

const GUID GUID_ASF_Data_Object =
	{0x75B22636, 0x668E, 0x11CF, {0xA6, 0xD9, 0x00, 0xAA, 0x00, 0x62, 0xCE, 0x6C}};

const GUID GUID_ASF_Audio_Media =
	{0xF8699E40, 0x5B4D, 0x11CF, {0xA8, 0xFD, 0x00, 0x80, 0x5F, 0x5C, 0x44, 0x2B}};

const GUID GUID_ASF_Video_Media =
	{0xBC19EFC0, 0x5B4D, 0x11CF, {0xA8, 0xFD, 0x00, 0x80, 0x5F, 0x5C, 0x44, 0x2B}};

const GUID GUID_ASF_No_Error_Correction =
	{0x20FB5700, 0x5B55, 0x11CF, {0xA8, 0xFD, 0x00, 0x80, 0x5F, 0x5C, 0x44, 0x2B}};

const GUID GUID_ASF_Audio_Spread =
	{0xBFC3CD50, 0x618F, 0x11CF, {0x8B, 0xB2, 0x00, 0xAA, 0x00, 0xB4, 0xE2, 0x20}};

#pragma pack(push)
#pragma pack(1)

// The spec defines many of these fields as
// QWORDs, which is uncommon in the Win32 API

#define QWORD UINT64

typedef struct {
	GUID		Object_ID;
	QWORD		Object_Size;
} ASF_Object;

typedef struct {
	DWORD		Number_Of_Header_Objects;
	BYTE		Reserved1;
	BYTE		Reserved2;
} ASF_Header_Object;

typedef struct {
	GUID		Reserved1;
	WORD		Reserved2;
	DWORD		Header_Extension_Data_Size;
} ASF_Header_Extension_Object;

typedef struct {
	QWORD		Start_Time;
	QWORD		End_Time;
	DWORD		Data_Bitrate;
	DWORD		Buffer_Size;
	DWORD		Initial_Buffer_Fullness;
	DWORD		Alternate_Data_Bitrate;
	DWORD		Alternate_Buffer_Size;
	DWORD		Alternate_Initial_Buffer_Fullness;
	DWORD		Maximum_Object_Size;
	DWORD		Flags;
	WORD		Stream_Number;
	WORD		Stream_Language_ID_Index;
	QWORD		Average_Time_Per_Frame;
	WORD		Stream_Name_Count;
	WORD		Payload_Extension_System_Count;
} ASF_Extended_Stream_Properties_Object;

typedef struct {
	WORD		Language_ID_Index;
	WORD		Stream_Name_Length;
} ASF_Stream_Name;

typedef struct {
	GUID		Extension_System_ID;
	WORD		Extension_Data_Size;
	DWORD		Extension_System_Info_Length;
} ASF_Payload_Extension_System;

typedef struct {
	GUID		File_ID_GUID;
	QWORD		File_Size;
	QWORD		Creation_Date;
	QWORD		Data_Packets_Count;
	QWORD		Play_Duration;	// in 100-nanosecond units
	QWORD		Send_Duration;	// in 100-nanosecond units
	QWORD		Preroll;		// in milliseconds
	DWORD		Flags;
	DWORD		Minimum_Data_Packet_Size;
	DWORD		Maximum_Data_Packet_Size;
	DWORD		Maximum_Bitrate;
} ASF_File_Properties_Object;

typedef struct {
	GUID		Stream_Type;
	GUID		Error_Correction_Type;
	QWORD		Time_Offset;	// in 100-nanosecond units
	DWORD		Type_Specific_Data_Length;
	DWORD		Error_Correction_Data_Length;
	WORD		Flags;
	DWORD		Reserved;
} ASF_Stream_Properties_Object;

typedef struct {
	GUID		File_ID_GUID;
	QWORD		Total_Data_Packets;
	WORD		Reserved;
} ASF_Data_Object;

#pragma pack(pop)

#endif	// f_WMVTYPES_H